/*===================================================================*/
/*                                                                   */
/*  K6502.h : Header file for K6502                                  */
/*                                                                   */
/*  1999/10/19  Racoon  New preparation                              */
/*  2000/06/12  Racoon                                               */
/*                                                                   */
/*===================================================================*/

#ifndef K6502_H_INCLUDED
#define K6502_H_INCLUDED

#include "pNesX_Types.h"

#define SCRATCH_PAD (BYTE *)0x1f800000

#define ROMBANK0 (*((BYTE **)(SCRATCH_PAD + 16)))
#define ROMBANK1 (*((BYTE **)(SCRATCH_PAD + 20)))
#define ROMBANK2 (*((BYTE **)(SCRATCH_PAD + 24)))
#define ROMBANK3 (*((BYTE **)(SCRATCH_PAD + 28)))

#define IRQ_STATE (*(SCRATCH_PAD + 40))
#define NMI_STATE (*(SCRATCH_PAD + 41))

// NMI Request
#define NMI_REQ  NMI_STATE = 0;

// IRQ Request
#define IRQ_REQ  IRQ_STATE = 0;

// Emulator Operation
void K6502_Init();
void K6502_Reset();
void K6502_Run();

// I/O Operation (User definition)
BYTE K6502_Read( WORD wAddr);
WORD K6502_ReadW( WORD wAddr );
void K6502_Write( WORD wAddr, BYTE byData );

#endif /* !K6502_H_INCLUDED */