#===================================================================#
#                                                                   #
#  K6502a.s : 6502 Emulator with NES I/O                            #
#                                                                   #
#  2000/05/27  Racoon  New preparation                              #
#                                                                   #
#===================================================================#

	.extern RAM,1
	.extern SRAM,1
	.extern PPURAM,1
	.extern PPUBANK,1
	.extern SPRRAM,1
	.extern PPU_R0,1
	.extern PPU_R1,1
	.extern PPU_R2,1
	.extern PPU_R3,1
	.extern PPU_R7,1
	.extern PPU_Latch_Flag,1
	.extern PPU_Scr_V_Next,1
	.extern PPU_Scr_V_Byte_Next,1
	.extern PPU_Scr_V_Bit_Next,1
	.extern PPU_Scr_H_Next,1
	.extern PPU_Scr_H_Byte_Next,1
	.extern PPU_Scr_H_Bit_Next,1
	.extern PPU_Addr,1
	.extern PPU_Increment,1
	.extern PPU_Scanline,1
	.extern PPU_NameTableBank,1
	.extern PPU_SP_Height,1
	.extern SpriteHitPos,1
	.extern byCLUT_Change,1
	
	.extern	FrameSkip,1
	.extern FrameCnt,1
	
	.extern ChrBufUpdate,1
	.extern PalTable,1
	
	.extern PPU_MirrorTable,1
	
	.extern PAD1_Bit,1
	.extern PAD2_Bit,1
	.extern PAD1_Latch,1
	.extern PAD2_Latch,1
	.extern PAD_System,1
	
	.extern MapperInit,1
	.extern MapperWrite,1
	.extern MapperVSync,1
	.extern MapperHSync,1
	
	.extern NesHeader,1
	.extern chFrameIRQ,1
	
	.extern APU_Reg,1
	.extern APU_Freq,1
	.extern APU_Len,1
	
        .offset $1f800000
        .align  4


	.globl	PalTable

        .offset $1f800000
        .align  4

BANK_TABLE:	.ds.l   1
BANK_TABLE1:	.ds.l	1
BANK_TABLE2:	.ds.l	1
BANK_TABLE3:	.ds.l	1
ROMBANK0:	.ds.l	1
ROMBANK1:	.ds.l	1
ROMBANK2:	.ds.l	1
ROMBANK3:	.ds.l	1

SP_PPC:		.ds.l   1
SP_PPC_OFF:	.ds.l   1

	.align	1
IRQ_STATE:	.ds.b   1
NMI_STATE:	.ds.b   1
IRQ_WIRING:	.ds.b   1
NMI_WIRING:	.ds.b   1

SP_SP:		.ds.b   1
SP_F:		.ds.b   1
SP_A:		.ds.b   1
SP_X:		.ds.b   1
SP_Y:		.ds.b   1

	.align	2
SP_CLOCK:	.ds.w   1

// 2 * 8
BANK_MASK:	.ds.w   8
// 256
TEST_TABLE:	.ds.b   256
// 256
LSHIFT_TABLE:	.ds.b   256
// 256
RSHIFT_TABLE:	.ds.b   256

	.sdata
	.align	4
CodeTable:
        .word Code00, Code01, CodeXX, CodeXX, CodeXX, Code05, Code06, CodeXX
        .word Code08, Code09, Code0A, CodeXX, CodeXX, Code0D, Code0E, CodeXX
        .word Code10, Code11, CodeXX, CodeXX, CodeXX, Code15, Code16, CodeXX
        .word Code18, Code19, CodeXX, CodeXX, CodeXX, Code1D, Code1E, CodeXX
        .word Code20, Code21, CodeXX, CodeXX, Code24, Code25, Code26, CodeXX
        .word Code28, Code29, Code2A, CodeXX, Code2C, Code2D, Code2E, CodeXX
        .word Code30, Code31, CodeXX, CodeXX, CodeXX, Code35, Code36, CodeXX
        .word Code38, Code39, CodeXX, CodeXX, CodeXX, Code3D, Code3E, CodeXX
        .word Code40, Code41, CodeXX, CodeXX, CodeXX, Code45, Code46, CodeXX
        .word Code48, Code49, Code4A, CodeXX, Code4C, Code4D, Code4E, CodeXX
        .word Code50, Code51, CodeXX, CodeXX, CodeXX, Code55, Code56, CodeXX
        .word Code58, Code59, CodeXX, CodeXX, CodeXX, Code5D, Code5E, CodeXX
        .word Code60, Code61, CodeXX, CodeXX, CodeXX, Code65, Code66, CodeXX
        .word Code68, Code69, Code6A, CodeXX, Code6C, Code6D, Code6E, CodeXX
        .word Code70, Code71, CodeXX, CodeXX, CodeXX, Code75, Code76, CodeXX
        .word Code78, Code79, CodeXX, CodeXX, CodeXX, Code7D, Code7E, CodeXX
        .word CodeXX, Code81, CodeXX, CodeXX, Code84, Code85, Code86, CodeXX
        .word Code88, CodeXX, Code8A, CodeXX, Code8C, Code8D, Code8E, CodeXX
        .word Code90, Code91, CodeXX, CodeXX, Code94, Code95, Code96, CodeXX
        .word Code98, Code99, Code9A, CodeXX, CodeXX, Code9D, CodeXX, CodeXX
        .word CodeA0, CodeA1, CodeA2, CodeXX, CodeA4, CodeA5, CodeA6, CodeXX
        .word CodeA8, CodeA9, CodeAA, CodeXX, CodeAC, CodeAD, CodeAE, CodeXX
        .word CodeB0, CodeB1, CodeXX, CodeXX, CodeB4, CodeB5, CodeB6, CodeXX
        .word CodeB8, CodeB9, CodeBA, CodeXX, CodeBC, CodeBD, CodeBE, CodeXX
        .word CodeC0, CodeC1, CodeXX, CodeXX, CodeC4, CodeC5, CodeC6, CodeXX
        .word CodeC8, CodeC9, CodeCA, CodeXX, CodeCC, CodeCD, CodeCE, CodeXX
        .word CodeD0, CodeD1, CodeXX, CodeXX, CodeXX, CodeD5, CodeD6, CodeXX
        .word CodeD8, CodeD9, CodeXX, CodeXX, CodeXX, CodeDD, CodeDE, CodeXX
        .word CodeE0, CodeE1, CodeXX, CodeXX, CodeE4, CodeE5, CodeE6, CodeXX
        .word CodeE8, CodeE9, CodeEA, CodeXX, CodeEC, CodeED, CodeEE, CodeXX
        .word CodeF0, CodeF1, CodeXX, CodeXX, CodeXX, CodeF5, CodeF6, CodeXX
        .word CodeF8, CodeF9, CodeXX, CodeXX, CodeXX, CodeFD, CodeFE, CodeXX


# 6502 Flags
FLAG_C  = $01
FLAG_Z  = $02
FLAG_I  = $04
FLAG_D  = $08
FLAG_B  = $10
FLAG_R  = $20
FLAG_V  = $40
FLAG_N  = $80

# line clocks
LINE_CLK = 114

        .text
        .align  4
        .set    noreorder

#===================================================================#
#                                                                   #
#                            Macro                                  #
#                                                                   #
#===================================================================#

#----------------------------------------------
#	Read / Write Macro
#----------------------------------------------

        macro   READ	clock
        sltiu   t8, a0, $2000
        bne     t8, zero, 1234f
        andi    t9, a0, 0x07ff

        la      ra, 4567f
        j       K6502_Read
        CLK	\clock
1234:
        la      t8, RAM
        addu    a0, t9, t8
        lbu     v0, 0(a0)
        CLK	\clock
4567:
        endm

        macro   READW	clock
        sltiu   t8, a0, $2000
        bne     t8, zero, 1234f
        andi    t9, a0, 0x07ff

        la      ra, 4567f
        j       K6502_ReadW
        CLK	\clock
1234:
        lbu     t8, RAM + 1(t9)
        lbu     v0, RAM(t9)
        sll     t8, 8
        or      v0, t8
        CLK	\clock
4567:
        endm

        macro   WRITE	clock
        sltiu   t8, a0, $2000
        bne     t8, zero, 1235f
        andi    t9, a0, 0x07ff

        la      ra, 4568f
        j       K6502_Write
        CLK	\clock
1235:
        la      t8, RAM
        addu    a0, t9, t8
        sb      a1, 0(a0)
        CLK	\clock
4568:
        endm

        
#----------------------------------------------
#	Addressing Macro AA_??
#
#	a0	: address
#----------------------------------------------

        # AA_IX
        macro   AA_IX
        lbu     t8, 0(s6)
        la      t9, RAM
        add     t8, s4  		# check ?
        add     t8, t9
        lbu     a0, 0(t8)
        lbu     t8, 1(t8)
        addi    s6, 1
        sll     t8, 8
        or      a0, t8
        endm

	# AA_IY
        macro   AA_IY
        lbu     t8, 0(s6)
        la      t9, RAM
        add     t8, t9
        lbu     a0, 0(t8)
        lbu     t8, 1(t8)
        addi    s6, 1
        sll     t8, 8
        or      a0, t8
        add     a0, s5
        endm
        
        # AA_ZP
        macro   AA_ZP
        lbu     a0, 0(s6)
        addi    s6, 1
        endm

	# AA_ZPX
        macro   AA_ZPX
        lbu     a0, 0(s6)
        addi    s6, 1
        add     a0, s4
        andi    a0, $ff
        endm

	# AA_ZPY
        macro   AA_ZPY
        lbu     a0, 0(s6)
        addi    s6, 1
        add     a0, s5
        andi    a0, $ff
        endm

	# AA_ABS
        macro   AA_ABS
        lbu     a0, 0(s6)
        lbu     t8, 1(s6)
        addi    s6, 2
        sll     t8, 8
        or      a0, t8
        endm

	# AA_ABSX
        macro   AA_ABSX
        AA_ABS
        add     a0, s4
        endm

	# AA_ABSY
        macro   AA_ABSY
        AA_ABS
        add     a0, s5
        endm
        
#----------------------------------------------
#	Addressing Macro A_??
#
#	A_ZP, A_ZPX, A_IMM
#	  reg	: Data
#	Others
#	  v0	: Data
#----------------------------------------------

	# A_IX
        macro   A_IX	clock
        AA_IX
        READ	\clock
        endm

	# A_IY
        macro   A_IY	clock
        AA_IY
        READ	\clock
        endm
        
        # A_ZP
        macro   A_ZP	reg, clock
        AA_ZP
        la      \reg, RAM
        addu    a0, \reg
        lbu     \reg, 0(a0)
        CLK	\clock
        endm
        
        # A_ZPX
        macro   A_ZPX	reg, clock
        AA_ZPX
        la      \reg, RAM
        addu    a0, \reg
        lbu     \reg, 0(a0)
        CLK	\clock
        endm

	# A_ZPY
        macro   A_ZPY	reg, clock
        AA_ZPY
        la      \reg, RAM
        addu    a0, \reg
        lbu     \reg, 0(a0)
        CLK	\clock
        endm
        
        # A_ABS
        macro   A_ABS	clock
        AA_ABS
        READ	\clock
        endm

	# A_ABSX
        macro   A_ABSX	clock
        AA_ABSX
        READ	\clock
        endm

	# A_ABSY
        macro   A_ABSY	clock
        AA_ABSY
        READ	\clock
        endm
        
        # A_IMM
        macro   A_IMM	reg, clock
        lbu     \reg, 0(s6)
        addi    s6, 1
        CLK	\clock
        endm
        
#----------------------------------------------
#	Operation Macro
#----------------------------------------------

        # SETF
        macro   SETF    flag
        ori     s2, \flag
        endm
        
        # RSTF
        macro   RSTF    flag
        andi    s2, (\flag) ^ $ff
        endm

        # TEST
        macro   TEST    reg
        lbu     t8, TEST_TABLE(\reg)
        RSTF    FLAG_N | FLAG_Z
        or      s2, t8
        endm

        # STORE
        macro   STORE   reg, clock
        move    a1, \reg
        WRITE	\clock
        endm
        
        # LOAD
        macro   LOAD    reg
        move    \reg, v0
        TEST    \reg
        endm
        
        # PUSH
        macro   PUSH    flag
        sb      \flag, RAM + $100(s1)
        subu    s1, 1
        andi    s1, $ff
        endm
        
        # PUSHW
        macro   PUSHW   flag
        srl     t8, \flag, 8
        sb      t8, RAM + $100(s1)
        sb      \flag, RAM + $ff(s1)
        subu    s1, 2
        andi    s1, $ff
        endm
        
        # POP
        macro   POP     flag
        lbu     \flag, RAM + $101(s1)
        addiu   s1, s1, 1
        andi    s1, $ff
        endm

        # POPW
        macro   POPW     flag
        lbu     \flag, RAM + $101(s1)
        lbu     t8, RAM + $102(s1)
        addiu   s1, 2
        andi    s1, $ff
        sll     t8, 8
        or      \flag, t8
        endm
        
        # ORA
        macro   ORA
        or      s3, v0
        TEST    s3
        endm
        
        # _AND
        macro   _AND
        and     s3, v0
        TEST    s3
        endm

        # EOR
        macro   EOR
        xor     s3, v0
        TEST    s3
        endm
        
        # BIT
        macro   BIT
        RSTF    FLAG_N | FLAG_V | FLAG_Z
        andi    t8, v0, FLAG_N | FLAG_V
        or      s2, t8
        and     t8, v0, s3
        sltiu   t9, t8, 1
        sll     t9, 1           	# z flag
        or      s2, t9
        endm
        
        # CMP
        macro   CMP     flag
        subu    t8, \flag, v0
        sltiu   t9, t8, $100
        andi    t8, $ff
        lbu     t8, TEST_TABLE(t8)
        RSTF    FLAG_N | FLAG_Z | FLAG_C
        or      s2, t8
        or      s2, t9          	# carry
        endm
        
        # ADC
        macro   ADC
        addu    t8, s3, v0
        andi    t9, s2, 1       	# carry
        addu    t8, t9          	# A + M + C
        andi    t9, t8, $ff

        RSTF    FLAG_N | FLAG_V | FLAG_Z | FLAG_C
        
        xor     v0, s3
        xori    v0, $ff
        
        xor     s3, t9
        and     s3, v0
        andi    s3, $80
        srl     s3, 1           	# v flag
        or      s2, s3
        
        sltiu   t8, t8, $100
        xori    t8, 1           	# 1 if result > $ff
        or      s2, t8          	# carry
        
        lbu     t8, TEST_TABLE(t9)
        move    s3, t9
        or      s2, t8
        endm
        
        # SBC
        macro   SBC
        subu    t8, s3, v0
        andi    t9, s2, 1       	# carry
        xori    t9, 1
        subu    t8, t9          	# A + M + C
        andi    t9, t8, $ff

        RSTF    FLAG_N | FLAG_V | FLAG_Z | FLAG_C
        
        xor     v0, s3
        xori    v0, $ff
        
        xor     s3, t9
        and     s3, v0
        andi    s3, $80
        srl     s3, 1           	# v flag
        or      s2, s3
        
        sltiu   t8, t8, $100    	# 1 if result < $100
        or      s2, t8          	# carry
        
        lbu     t8, TEST_TABLE(t9)
        move    s3, t9
        or      s2, t8
        endm

        # DEC
        macro   DEC
        subu    v0, v0, 1
        sb      v0, 0(a0)
        andi    v0, $ff
        TEST    v0
        endm

        # INC
        macro   INC
        add     v0, v0, 1
        sb      v0, 0(a0)
        andi    v0, $ff
        TEST    v0
        endm

        # ASLA
        macro   ASLA
        RSTF    FLAG_N | FLAG_Z | FLAG_C
        lbu     t8, LSHIFT_TABLE(s3)
        sll     s3, 1
        andi    s3, $ff
        or      s2, t8
        endm
        
        # ASL
        macro   ASL
        RSTF    FLAG_N | FLAG_Z | FLAG_C
        lbu     t8, LSHIFT_TABLE(v0)
        sll     v0, 1
        sb      v0, 0(a0)
        or      s2, t8
        endm
        
        # LSRA
        macro   LSRA
        RSTF    FLAG_N | FLAG_Z | FLAG_C
        lbu     t8, RSHIFT_TABLE(s3)
        srl     s3, 1
        or      s2, t8
        endm

        # LSR
        macro   LSR
        RSTF    FLAG_N | FLAG_Z | FLAG_C
        lbu     t8, RSHIFT_TABLE(v0)
        srl     v0, 1
        sb      v0, 0(a0)
        or      s2, t8
        endm

        # ROLA
        macro   ROLA
        srl     t9, s3, 7       	# carry -> bit0
        sll     s3, 1
        andi    t8, s2, FLAG_C  	# bit0
        or      s3, t8
        andi    s3, $ff
        lbu     t8, TEST_TABLE(s3)
        RSTF    FLAG_N | FLAG_Z | FLAG_C
        or      s2, t8
        or      s2, t9          	# carry
        endm

        # ROL
        macro   ROL
        srl     t9, v0, 7       	# carry -> bit0
        sll     v0, 1
        andi    t8, s2, FLAG_C  	# bit0
        or      v0, t8
        andi    v0, $ff
        sb      v0, 0(a0)
        lbu     t8, TEST_TABLE(v0)
        RSTF    FLAG_N | FLAG_Z | FLAG_C
        or      s2, t8
        or      s2, t9          	# carry
        endm

        # RORA
        macro   RORA
        andi    t9, s3, 1       	# carry -> bit0
        srl     s3, 1
        sll     t8, s2, 7       	# bit7
        or      s3, t8
        andi    s3, $ff
        lbu     t8, TEST_TABLE(s3)
        RSTF    FLAG_N | FLAG_Z | FLAG_C
        or      s2, t8
        or      s2, t9          	# carry
        endm

        # ROR
        macro   ROR
        andi    t9, v0, 1       	# carry -> bit0
        srl     v0, 1
        sll     t8, s2, 7       	# bit7
        or      v0, t8
        andi    v0, $ff
        sb      v0, 0(a0)
        lbu     t8, TEST_TABLE(v0)
        RSTF    FLAG_N | FLAG_Z | FLAG_C
        or      s2, t8
        or      s2, t9          	# carry
        endm

        # JSR
        macro   JSR
        AA_ABS
        subu    s6, 1
        VIRPC   t0
        PUSHW   t0
        move    t0, a0
        REALPC  t0
        endm
        
        # BRA
        macro   BRA     cond, set
        andi    t8, s2, \cond
.if \set
        beq     t8, zero, 1236f
.else
        bne     t8, zero, 1236f
.endif
					# jump
	addi	s6, 1
	
	lb	t8, -1(s6)
	CLK	4
	add	s6, t8
        DONE
1236:
        				# next
        CLK     2
        DONE
        endm

        # JMP
        macro   JMP     reg
        move    t0, \reg
        REALPC  t0
        endm
        
#----------------------------------------------
#	Other Macro
#----------------------------------------------

        # CLK
        macro   CLK     clock
        addi    s0, \clock
        endm
        
        # DONE
        macro   DONE
        j	Fetch3
        sltiu   t0, s0, LINE_CLK
        endm
        
        # REALPC
        macro   REALPC  reg
        srl     t8, \reg, 11
        andi    t8, $1c
        srl     t7, t8, 1
        lhu     t7, BANK_MASK(t7)
        lw      t9, BANK_TABLE(t8)
        and     t7, \reg
        subu    s7, t9, t7
        add     s6, s7, \reg
        endm
        
        # VIRPC
        macro   VIRPC     reg
        subu    \reg, s6, s7
        endm

#===================================================================#
#                                                                   #
#                K6502_Init() : Initialize K6502                    #
#                                                                   #
#===================================================================#
        .globl  K6502_Init
        .ent    K6502_Init

K6502_Init:
	li	t0, $f800
	sh	t0, BANK_MASK
	li	t1, $f800
	sh	t1, BANK_MASK + 2
	li	t0, $f800
	sh	t0, BANK_MASK + 4
	li	t1, $e000
	sh	t1, BANK_MASK + 6
	li	t0, $e000
	sh	t0, BANK_MASK + 8
	li	t1, $e000
	sh	t1, BANK_MASK + 10
	li	t0, $e000
	sh	t0, BANK_MASK + 12
	li	t1, $e000
	sh	t1, BANK_MASK + 14
	
	li	t0, 1
	sb	t0, NMI_WIRING
	sb	t0, NMI_STATE
	sb	t0, IRQ_WIRING
	sb	t0, IRQ_STATE
	nop
	
	# TEST_TABLE
	li	t0, $ff
111:
	andi	t1, t0, $80
	sb	t1, TEST_TABLE(t0)
	subu	t0, 1
	bne	t0, zero, 111b
	nop
	li	t1, FLAG_Z
	sb	t1, TEST_TABLE
	nop
	
	# LSHIFT_TABLE
	li	t0, $ff
111:
	andi	t2, t0, $80
	srl	t2, 7			# carry
	
	sll	t1, t0, 1
	andi	t1, $ff
	
	bne	t1, zero, 222f
	nop
	ori	t2, FLAG_Z
	j	333f
	nop
222:
	andi	t1, $80
	beq	t1, zero, 333f
	nop
	ori	t2, FLAG_N
333:
	sb	t2, LSHIFT_TABLE(t0)
	subu	t0, 1
	bgez	t0, 111b
	nop
	
	# RSHIFT_TABLE
	li	t0, $ff
111:
	andi	t2, t0, 1		# carry
	
	andi	t1, t0, $fe
	bne	t1, zero, 222f
	nop
	ori	t2, FLAG_Z
	j	222f
	nop
222:
	sb	t2, RSHIFT_TABLE(t0)
	subu	t0, 1
	bgez	t0, 111b
	nop
	
	jr	ra
	nop
	.end	K6502_Init

#===================================================================#
#                                                                   #
#                K6502_Reset() : Reset a CPU                        #
#                                                                   #
#===================================================================#
        .globl  K6502_Reset
        .ent    K6502_Reset
K6502_Reset:
        subu    sp, sp, 4 * 3 + 16
        sw      ra, 16(sp)
        sw      s6, 20(sp)
        sw      s7, 24(sp)

	la	t0, RAM
	sw	t0, BANK_TABLE
	sw	t0, BANK_TABLE + 4
	sw	t0, BANK_TABLE + 8
	la	t1, SRAM
	sw	t1, BANK_TABLE + 12
	
	li	a0, $fffc		# VECTOR_RESET
	jal	K6502_ReadW
	nop
	REALPC	v0
        sw      s6, SP_PPC
        sw      s7, SP_PPC_OFF

	li	t0, $ff
	sb	t0, SP_SP
	sb	zero, SP_A
	sb	zero, SP_X
	sb	zero, SP_Y
	li	t0, FLAG_Z | FLAG_R
	sb	t0, SP_F
	nop
	
	lbu	t0, NMI_WIRING
	lbu	t1, IRQ_WIRING
	sb	t0, NMI_STATE
	sb	t1, IRQ_STATE
	
	sh	zero, SP_CLOCK
	nop
	
        lw      ra, 16(sp)
        lw      s6, 20(sp)
        lw      s7, 24(sp)
	addu	sp, sp, 4 * 3 + 16
	
	jr	ra
	nop
	.end	K6502_Reset

#===================================================================#
#                                                                   #
#             pNesX_PadState() : Get a joypad state                 #
#                                                                   #
#===================================================================#
	.sdata
dwSysOld:	.word 0
nWait:		.word 0
	.text
	
	.globl	pNesX_PadState
	.ent	pNesX_PadState

P_SELECT =   0x01
P_START =    0x08
P_UP =       0x10
P_RIGHT =    0x20
P_DOWN =     0x40
P_LEFT =     0x80

P_L1 =       0x0400
P_TRIANGLE = 0x1000
P_CIRCLE =   0x2000
P_CROSS =    0x4000
P_SQUARE =   0x8000


pNesX_PadState:
	la	a3, GetPadState

	# joypad 2
	lw	t0, bb1
	nop
	jalr	t7, a3
	nop
	sw	t8, 0(a1)
	
	# joypad 1
	lw	t0, bb0
	nop
	jalr	t7, a3
	nop
	sw	t8, 0(a0)
	nop

	# system
	andi	t8, t0, P_L1
	srl	t8, 10
	
	andi	t1, t0, P_CIRCLE | P_CROSS
	srl	t1, 12
	or	t8, t1

	andi	t1, t0, P_UP
	srl	t1, 1
	or	t8, t1
	
	andi	t1, t0, P_DOWN | P_LEFT
	srl	t1, 2
	or	t8, t1
	
	andi	t1, t0, P_RIGHT
	sll	t1, 1
	or	t8, t1

	# key repeat
	lw	t0, dwSysOld
	nop
	bne	t0, t8, 111f
	nop
	lw	t1, nWait
	nop
	addi	t1, 1
	sw	t1, nWait
	slti	t2, t1, 16
	bne	t2, zero, 222f
	nop
	andi	t1, 3
	bne	t1, zero, 222f
	nop
	move	t0, zero
	j	222f
	nop
111:
	sw	zero, nWait
222:
	xori	t1, t0, $ffff
	and	t2, t1, t8
	sw	t2, 0(a2)
	
	sw	t8, dwSysOld
	nop
	
	jr	ra
	nop
	
GetPadState:
	lhu	t0, 2(t0)
	nop
	xor	t0, $ffff
	andi	t8, t0, P_START | P_UP
	
	# CIRCLE | SQUARE
	srl	t1, t0, 2
	or	t2, t0, t1
	andi	t2, P_CIRCLE
	srl	t2, 13
	or	t8, t2
	
	# CROSS | TRIANGLE
	srl	t1, t0, 2
	or	t2, t0, t1
	andi	t2, P_TRIANGLE
	srl	t2, 11
	or	t8, t2
	
	andi	t1, t0, P_SELECT
	sll	t1, 2
	or	t8, t1
	
	andi	t1, t0, P_DOWN | P_LEFT
	srl	t1, 1
	or	t8, t1
	
	andi	t1, t0, P_RIGHT
	sll	t1, 2
	or	t8, t1
	
	sll	t9, t8, 8
	or	t8, t9
	
	jr	t7
	nop
	
	.end	pNesX_PadState

	
#===================================================================#
#                                                                   #
#                        K6502_Read() :                             #
#                                                                   #
#===================================================================#
        .globl  K6502_Read
        .ent    K6502_Read
K6502_Read:
        srl     t2, a0, 11
        andi    t2, $1c
        lw      t1, _ReadBank(t2)
        nop
        jr      t1
        nop
        .sdata
_ReadBank:
        .word   r0000, r2000, r4000, r6000, r8000, ra000, rc000, re000
	.text
r0000:
        andi    t0, a0, 0x07ff
        la      t1, RAM
        addu    a0, t1, t0
        lbu     v0, 0(a0)
        nop
        jr      ra
        nop
r2000:
        andi    t0, a0, 7
        li      t1, 7
        beq     t0, t1, 111f
        nop
                                	# PPU Status
        lbu     v0, PPU_R2
        sb      zero, PPU_Latch_Flag
        andi    t0, v0, $7f

        lhu     t1, PPU_Scanline
        sb      t0, PPU_R2
        slti    t2, t1, 243
        bgtz    t2, 222f        	# if PPU_Scanline < 243 then 222
        
        
        lbu     t3, PPU_R0
        nop
        andi    t4, t3, $fc             # ~R0_NAME_ADDR
        andi    t3, $80
        bgtz    t3, 222f        	# R0_NMI_VB
        nop
        
        
        li      t5, 8           	# NAME_TABLE0
        sb      t4, PPU_R0
        sb      t5, PPU_NameTableBank
        nop
        
222:                            	# return
        jr      ra
        nop
111:                            	# PPU Memory
        lbu     v0, PPU_R7
        lhu     t0, PPU_Addr
        la      t3, PPUBANK
        srl     t1, t0, 10 - 2
        andi    t1, $3c
        addu    t3, t1
        lw      t1, 0(t3)
        andi    t2, t0, $3ff
        addu    t1, t2
        lbu     t2, 0(t1)
        lhu     t1, PPU_Increment
        sb      t2, PPU_R7
        
        addu    t1, t0
        andi    t1, $3fff
        sh      t1, PPU_Addr
        nop
        jr      ra
        nop
r4000:                          	# APU
        addi    t0, a0, -$4016
        bne     t0, zero, 111f
        nop
        
        # 4016
        lw      t1, PAD1_Bit
        lw      t0, PAD1_Latch
        addi    t2, t1, -23
        srlv    t0, t0, t1
        
        beq     t2, zero, 222f
        andi    t0, 1

        
        addi    t1, 1
        sw      t1, PAD1_Bit
        ori     v0, t0, $40
        jr      ra
        nop
222:
        sw      zero, PAD1_Bit
        ori     v0, t0, $40
        jr      ra
        nop
111:
        addi    t0, a0, -$4017
        bne     t0, zero, 999f
        nop
        
        # 4017
        lw      t1, PAD2_Bit
        lw      t0, PAD2_Latch
        addi    t2, t1, -23
        srlv    t0, t0, t1
        
        beq     t2, zero, 222f
        andi    t0, 1

        addi    t1, 1
        sw      t1, PAD2_Bit
        ori     v0, t0, $40
        jr      ra
        nop
222:
        sw      zero, PAD2_Bit
        ori     v0, t0, $40
        jr      ra
        nop
        
999:
        srl     v0, a0, 8
	jr	ra
	nop
	
r6000:
        la      t0, SRAM
        andi    t1, a0, $1fff
        addu    a0, t0, t1
        lbu     v0, 0(a0)
        nop
        jr      ra
        nop
        
r8000:
        lw      t0, ROMBANK0
        andi    t1, a0, $1fff
        addu    a0, t0, t1
        lbu     v0, 0(a0)
        nop
        jr      ra
        nop
        
ra000:
        lw      t0, ROMBANK1
        andi    t1, a0, $1fff
        addu    a0, t0, t1
        lbu     v0, 0(a0)
        nop
        jr      ra
        nop

rc000:
        lw      t0, ROMBANK2
        andi    t1, a0, $1fff
        addu    a0, t0, t1
        lbu     v0, 0(a0)
        nop
        jr      ra
        nop

re000:
        lw      t0, ROMBANK3
        andi    t1, a0, $1fff
        addu    a0, t0, t1
        lbu     v0, 0(a0)
        nop
        jr      ra
        nop

        .end    K6502_Read

#===================================================================#
#                                                                   #
#                        K6502_ReadW() :                            #
#                                                                   #
#===================================================================#
        .globl  K6502_ReadW
        .ent    K6502_ReadW
K6502_ReadW:
	move	a1, ra
	jal	K6502_Read
	nop
	lbu	t0, 1(a0)
	nop
	sll	t0, 8
	or	v0, t0
	
	jr	a1
	nop
	.end	K6502_ReadW

#===================================================================#
#                                                                   #
#                        K6502_Write() :                            #
#                                                                   #
#===================================================================#
        .globl  K6502_Write
        .ent    K6502_Write
K6502_Write:
        srl     t2, a0, 11
        andi    t2, $1c
        lw      t1, _WriteBank(t2)
        nop
        jr      t1
        nop
        .sdata
_WriteBank:
        .word   w0000, w2000, w4000, w6000, w8000, wa000, wc000, we000
	.text
w0000:
        andi    t0, a0, $7ff
        sb      a1, RAM(t0)
        nop
        jr      ra
        nop
w2000:
        andi    t0, a0, 7
        sll     t0, 2
        lw      t1, _PPUBank(t0)
        nop
        jr      t1
        nop
        .sdata
_PPUBank:
        .word   p2000, p2001, p2002, p2003, p2004, p2005, p2006, p2007
        .text


p2000:
        sb      a1, PPU_R0
        
        li      t1, 32
        andi    t0, a1, 4       	# R0_INC_ADDR
        bne     t0, zero, 111f
        nop
        li      t1, 1
111:
        sh      t1, PPU_Increment
        
        andi    t0, a1, 3       	# R0_NAME_ADDR   0x03
        addi    t0, 8           	# NAME_TABLE0  8
        sb      t0, PPU_NameTableBank
        
        li      t1, 16
        andi    t0, a1, $20     	# R0_SP_SIZE     0x20
        bne     t0, zero, 111f
        nop
        li      t1, 8
111:
        sh      t1, PPU_SP_Height
        nop
        
        jr      ra
        nop
        
p2001:
        sb      a1, PPU_R1
        nop
        jr      ra
        nop
        
p2002:
        jr      ra
        nop
        
p2003:
        sb      a1, PPU_R3
        nop
        jr      ra
        nop
        
p2004:
        # SPRRAM[ PPU_R3++ ] = byData;
        lbu     t0, PPU_R3
        nop
        sb      a1, SPRRAM(t0)
        addi    t0, 1
        sb      t0, PPU_R3
        nop
        jr      ra
        nop
p2005:
        lbu     t0, PPU_Latch_Flag
        nop
        andi    t0, 1
        sltu    t1, a1, 240
        beq     t0, zero, 222f
        nop
        
        # V-Scroll Register
        # PPU_Scr_V_Next = ( byData > 239 ) ? 0 : byData;
        # PPU_Scr_V_Byte_Next = PPU_Scr_V_Next >> 3;
        # PPU_Scr_V_Bit_Next = PPU_Scr_V_Next & 7;

        bne     t1, zero, 111f
        nop
        move    a1, zero
111:
        sb      a1, PPU_Scr_V_Next
        srl     t2, a1, 3
        sb      t2, PPU_Scr_V_Byte_Next
        andi    t3, a1, 7
        sb      t3, PPU_Scr_V_Bit_Next
        sb      zero, PPU_Latch_Flag
        nop
        jr      ra
        nop
        
222:
        # H-Scroll Register
        # PPU_Scr_H_Next = byData;
        # PPU_Scr_H_Byte_Next = PPU_Scr_H_Next >> 3;
        # PPU_Scr_H_Bit_Next = PPU_Scr_H_Next & 7;

        sb      a1, PPU_Scr_H_Next
        srl     t2, a1, 3
        sb      t2, PPU_Scr_H_Byte_Next
        andi    t3, a1, 7
        sb      t3, PPU_Scr_H_Bit_Next
        li      t0, 1
        sb      t0, PPU_Latch_Flag
        nop
        jr      ra
        nop
        
p2006:
        lbu     t0, PPU_Latch_Flag
        nop
        andi    t0, 1
        beq     t0, zero, 111f
        nop
        
        lhu     t0, PPU_Addr
        nop
        or      t0, a1
        sh      t0, PPU_Addr
        sb      zero, PPU_Latch_Flag
        nop
        jr      ra
        nop
111:
        andi    t0, a1, $3f
        sll     t0, 8
        sh      t0, PPU_Addr
        li      t1, 1
        sb      t1, PPU_Latch_Flag
        nop
        jr      ra
        nop

p2007:
        lhu     t0, PPU_Addr
        lhu     t3, PPU_Increment
        sltu    t1, t0, $2000
        beq     t1, zero, 111f
        
        lbu     t2, NesHeader + 5
        srl     t1, t0, 10
        bne     t2, zero, 111f
        li      t4, 1
        
        lbu     t2, ChrBufUpdate
        sll     t1, t4, t1
        or      t2, t1
        sb      t2, ChrBufUpdate
        
        sb      a1, PPURAM(t0)

        add     t0, t3
        andi    t0, $3fff
        sh      t0, PPU_Addr
        nop
        jr      ra
        nop
111:
        sltu    t1, t0, $3f00
        beq     t1, zero, 222f
        nop
        
        la      t1, PPUBANK
        srl     t2, t0, 10 - 2
        andi    t2, $3c
        addu    t1, t2
        lw      t1, 0(t1)
        andi    t2, t0, $3ff
        addu    t1, t2
        sb      a1, 0(t1)

        add     t0, t3
        andi    t0, $3fff
        sh      t0, PPU_Addr
        nop
        jr      ra
        nop
222:
        andi    t1, t0, $f
        bne     t1, zero, 333f
        nop
        
        sb      a1, PPURAM + $3f10
        sb      a1, PPURAM + $3f14
        sb      a1, PPURAM + $3f18
        sb      a1, PPURAM + $3f1c
        sb      a1, PPURAM + $3f00
        sb      a1, PPURAM + $3f04
        sb      a1, PPURAM + $3f08
        sb      a1, PPURAM + $3f0c
        
        la      t1, NesPalette
        sll     t2, a1, 1
        addu    t1, t2
        lhu     t1, 0(t1)
        nop
        ori     t1, $8000
        sh      t1, PalTable
        sh      t1, PalTable + 4 * 2
        sh      t1, PalTable + 8 * 2
        sh      t1, PalTable + $c * 2
        sh      zero, PalTable + $10 * 2
        sh      zero, PalTable + $14 * 2
        sh      zero, PalTable + $18 * 2
        sh      zero, PalTable + $1c * 2

        li      t1, 1
        sb      t1, byCLUT_Change
        
        add     t0, t3
        andi    t0, $3fff
        sh      t0, PPU_Addr
        nop
        jr      ra
        nop
333:
        andi    t1, t0, $3
        beq     t1, zero, 999f
        add     t4, t0, t3          	# for 999
        sb      a1, PPURAM(t0)

        la      t1, NesPalette
        sll     t2, a1, 1
        addu    t1, t2
        lhu     t1, 0(t1)
        andi    t2, t0, $1f
        ori     t1, $8000

        sll     t2, 1
        
        sh      t1, PalTable(t2)
        
        li      t1, 1
        sb      t1, byCLUT_Change

999:
        andi    t4, $3fff
        sh      t4, PPU_Addr
        nop
        jr      ra
        nop

w4000:
        subu    sp, sp, 3 * 4 + 16
        sw      ra, 16(sp)
        sw      s0, 20(sp)
        sw      s1, 24(sp)
        
        move    s0, a0
        move    s1, a1

        andi    t0, a0, $1f
        sll     t0, 2
        lw      t1, APUBank(t0)
        nop
        jr      t1
        nop
        .sdata
        .align	4
APUBank:
        .word   a4000, a4001, a4002, a4003, a4004, a4005, a4006, a4007
        .word   a4008, a4009, a400a, a400b, a400c, a400d, a400e, a400f
        .word   a4010, a4011, a4012, a4013, a4014, a4015, a4016, a4017
        .word   apu_end, apu_end, apu_end, apu_end, apu_end, apu_end, apu_end, apu_end
        .text

a4014:
        srl     t0, a1, 3
        andi    t0, $1c
        lw      t1, SprDmaTbl(t0)
        nop
        jr       t1
        nop
        .sdata
SprDmaTbl:
        .word   SprDma0, apu_reg, apu_reg, SprDma3, SprDma4, SprDma5, SprDma6, SprDma7
	.text
SprDma0:
        sll     t0, a1, 8
        andi    t0, $7ff
        la      a1, RAM
        addu    a1, t0
        la      a0, SPRRAM
        li      a2, 256
        jal     pNesX_MemoryCopy
        nop
        j       333f
        nop
        
SprDma3:
        sll     t0, a1, 8
        andi    t0, $1fff
        la      a1, SRAM
        addu    a1, t0
        la      a0, SPRRAM
        li      a2, 256
        jal     pNesX_MemoryCopy
        nop
        j       333f
        nop
        
SprDma4:
        sll     t0, a1, 8
        andi    t0, $1fff
        lw      a1, ROMBANK0
        la      a0, SPRRAM
        addu    a1, t0
        li      a2, 256
        jal     pNesX_MemoryCopy
        nop
        j       333f
        nop
        
SprDma5:
        sll     t0, a1, 8
        andi    t0, $1fff
        lw      a1, ROMBANK1
        la      a0, SPRRAM
        addu    a1, t0
        li      a2, 256
        jal     pNesX_MemoryCopy
        nop
        j       333f
        nop
        
SprDma6:
        sll     t0, a1, 8
        andi    t0, $1fff
        lw      a1, ROMBANK2
        la      a0, SPRRAM
        addu    a1, t0
        li      a2, 256
        jal     pNesX_MemoryCopy
        nop
        j       333f
        nop
        
SprDma7:
        sll     t0, a1, 8
        andi    t0, $1fff
        lw      a1, ROMBANK3
        la      a0, SPRRAM
        addu    a1, t0
        li      a2, 256
        jal     pNesX_MemoryCopy
        nop
        j       333f
        nop
        

a4016:
        lbu     t0, APU_Reg + $16
        andi    t1, a1, 1
        andi    t0, 1
        bne     t0, zero, 333f
        nop
        beq     t1, zero, 333f
        nop
        sw      zero, PAD1_Bit
        sw      zero, PAD2_Bit
        nop
	j	333f
	nop
	

        .sdata
nes_psg_atl:
	#.byte	5, 127, 10, 1, 20,  2, 40,  3, 80,  4, 30,  5, 7,  6, 13,  7
    	#.byte	6,   8, 12, 9, 24, 10, 48, 11, 96, 12, 36, 13, 8, 14, 16, 15

	.byte	5,  64, 10, 1, 20,  2, 38,  3, 50,  4, 30,  5, 7,  6, 13,  7
    	.byte	6,   8, 12, 9, 24, 10, 42, 11, 54, 12, 36, 13, 8, 14, 16, 15
    	.text
    	.align 4
	
a4002:
a4003:
a4006:
a4007:
a400a:
a400b:
a400e:
a400f:
	andi    t0, s0, $1f
        sb      s1, APU_Reg(t0)

	srl	a0, s0, 2
	andi	a0, 3			# a0 = channel
	la	t3, APU_Reg
	andi	t0, s0, $fc
	addu	t3, t0
	lbu	t4, 0(t3)		# t4 = env

	lbu	t2, 3(t3)
	lbu	t3, 2(t3)
	andi	t1, t2, $7
	sll	t1, 8
	or	t1, t3
	addi	t1, 1

	li	t0, 111861
	
	divu	t0, t1
	andi	t3, t4, $10
	li	t4, 15
	beq	t3, zero, 111f
	nop
	
	srl	t2, 3
	lbu	t4, nes_psg_atl(t2)
111:
	sb	t4, APU_Len(a0)

	sll	t2, a0, 1
	mflo	a1

	sh	a1, APU_Freq(t2)
	
	jal	pNesX_SetFreq
	nop
	
	srl	a0, s0, 2
	andi	a0, 3			# a0 = channel
	li	a1, 10
	jal	pNesX_SetVolume
	nop
	
	j	apu_end
	nop

a4015:
	li	a0, 4
111:
	beq	a0, zero, apu_reg
	nop
	subu	a0, 1
	
	srl	t0, s1, a0
	andi	t0, 1
	bne	t0, zero, 111b
	nop
	
	sb	zero, APU_Len(a0)
	li	a1, 0

	sw	a0, 12(sp)
	jal	pNesX_SetVolume
	nop
	lw	a0, 12(sp)
	nop
	
	j	111b
	nop
	
a4000:
a4004:
a4008:
a400c:
	# CH Reg 0 ( Envelope )
	
	
	#j	apu_reg
	#nop
	
a4010:
a4011:
a4012:
a4013:
a4017:

a4001:
a4005:
a4009:
a400d:

apu_reg:
333:
        andi    t0, s0, $1f
        sb      s1, APU_Reg(t0)
apu_end:
        lw      ra, 16(sp)
        lw      s0, 20(sp)
        lw      s1, 24(sp)
        addu    sp, sp, 3 * 4 + 16
        jr      ra
        nop

        
w6000:
        andi    t0, a0, $1fff
        sb      a1, SRAM(t0)
        nop
        jr      ra
        nop
w8000:
wa000:
wc000:
we000:
        subu    sp, sp, 4 + 16
        sw      ra, 16(sp)
        
        lw      t0, MapperWrite
        nop
        jal     t0
        nop

        lw      ra, 16(sp)
        addu    sp, sp, 4 + 16
        
        jr      ra
        nop
        .end    K6502_Write

#===================================================================#
#                                                                   #
#                          K6502_Run() :                            #
#                                                                   #
#===================================================================#
        .globl  K6502_Run
        .ent    K6502_Run

K6502_Run:
        subu    sp, sp, 9 * 4 + 16
        sw      ra, 16(sp)
        sw      s0, 20(sp)
        sw      s1, 24(sp)
        sw      s2, 28(sp)
        sw      s3, 32(sp)
        sw      s4, 36(sp)
        sw      s5, 40(sp)
        sw      s6, 44(sp)
        sw      s7, 48(sp)

        la	gp, _gp

        lhu     s0, SP_CLOCK
        lbu     s1, SP_SP
        lbu     s2, SP_F
        lbu     s3, SP_A
        lbu     s4, SP_X
        lbu     s5, SP_Y
        lw      s6, SP_PPC
        lw      s7, SP_PPC_OFF
        
Fetch:
        sltiu   t0, s0, LINE_CLK
Fetch3:
        beq     t0, zero, LineSync
        nop
Fetch2:
        lbu     t0, 0(s6)		# Code
        addiu   s6, 1
        sll     t0, 2
        lw      t0, CodeTable(t0)
        nop
        jr      t0
        nop
        
Code00: # BRK
        VIRPC   t0
        addiu   t0, 1
        PUSHW   t0
        SETF    FLAG_B
        PUSH    s2
        SETF    FLAG_I
        RSTF    FLAG_D
        li      a0, $fffe       	# VECTOR_IRQ
        jal     K6502_ReadW
        CLK     7
        REALPC  v0
        
        DONE
        
Code01: # ORA (Zpg,X)
        A_IX	6
        ORA
        DONE
        
Code05: # ORA Zpg
        A_ZP	v0, 3
        ORA
        DONE
        
Code06: # ASL Zpg
        A_ZP	v0, 5
        ASL
        DONE
        
Code08: # PHP
        PUSH s2
        CLK     3
        DONE
        
Code09: # ORA #Oper
        A_IMM	v0, 2
        ORA
        DONE
        
Code0A: # ASL A
        ASLA
        CLK     2
        DONE
        
Code0D: # ORA Abs
        A_ABS	4
        ORA
        DONE
        
Code0E: # ASL Abs
        A_ABS	6
        ASL
        DONE
        
Code10: # BPL Oper
        BRA     FLAG_N, 0
        
Code11: # ORA (Zpg),Y
        A_IY	5
        ORA
        DONE
        
Code15: # ORA Zpg,X
        A_ZPX	v0, 4
        ORA
        DONE
        
Code16: # ASL Zpg,X
        A_ZPX	v0, 6
        ASL
        DONE
        
Code18: # CLC
        RSTF    FLAG_C
        CLK     2
        DONE
        
Code19: # ORA Abs,Y
        A_ABSY	4
        ORA
        DONE
       
Code1D: # ORA Abs,X
        A_ABSX	4
        ORA
        DONE
        
Code1E: # ASL Abs,X
        A_ABSX	7
        ASL
        DONE

Code20: # JSR Abs
        JSR
        CLK     6
        DONE
        
Code21: # AND (Zpg,X)
        A_IX	6
        _AND
        DONE
        
Code24: # BIT Zpg
        A_ZP	v0, 3
        BIT
        DONE
        
Code25: # AND Zpg
        A_ZP	v0, 3
        _AND
        DONE
        
Code26: # ROL Zpg
        A_ZP	v0, 5
        ROL
        DONE

Code28: # PLP
        POP     s2
        SETF    FLAG_R
        CLK     4
        DONE
        
Code29: # AND #Oper
        A_IMM	v0, 2
        _AND
        DONE
        
Code2A: # ROL A
        ROLA
        CLK     2
        DONE
        
Code2C: # BIT Abs
        A_ABS	4
        BIT
        DONE
        
Code2D: # AND Abs
        A_ABS	4
        _AND
        DONE
        
Code2E: # ROL Abs
        A_ABS	6
        ROL
        DONE

Code30: # BMI Oper
        BRA     FLAG_N, 1
        
Code31: # AND (Zpg),Y
        A_IY	5
        _AND
        DONE
        
Code35: # AND Zpg,X
        A_ZPX	v0, 4
        _AND
        DONE
        
Code36: # ROL Zpg,X
        A_ZPX	v0, 6
        ROL
        DONE
        
Code38: # SEC
        SETF    FLAG_C
        CLK     2
        DONE
        
Code39: # AND Abs,Y
        A_ABSY	4
        _AND
        DONE
       
Code3D: # AND Abs,X
        A_ABSX	4
        _AND
        DONE
       
Code3E: # ROL Abs,X
        A_ABSX	7
        ROL
        DONE

Code40: # RTI
        POP     s2
        SETF    FLAG_R
        POPW    t0
        REALPC  t0
        CLK     6
        DONE
        
Code41: # EOR (Zpg,X)
        A_IX	6
        EOR
        DONE

Code45: # EOR Zpg
        A_ZP	v0, 3
        EOR
        DONE
        
Code46: # LSR Zpg
        A_ZP	v0, 5
        LSR
        DONE
        
Code48: # PHA
        PUSH s3
        CLK     3
        DONE
        
Code49: # EOR #Oper
        A_IMM	v0, 2
        EOR
        DONE
        
Code4A: # LSR A
        LSRA
        CLK     2
        DONE
        
Code4C: # JMP Abs
        AA_ABS
        JMP     a0
        CLK     3
        DONE
        
Code4D: # EOR Abs
        A_ABS	4
        EOR
        DONE
        
Code4E: # LSR Abs
        A_ABS	6
        LSR
        DONE

Code50: # BVC
        BRA     FLAG_V, 0
        
Code51: # EOR (Zpg),Y
        A_IY	5
        EOR
        DONE
        
Code55: # EOR Zpg,X
        A_ZPX	v0, 4
        EOR
        DONE
        
Code56: # LSR Zpg,X
        A_ZPX	v0, 6
        LSR
        DONE
        
Code58: # CLI
        RSTF    FLAG_I
        CLK	2
        DONE
        
Code59: # EOR Abs,Y
        A_ABSY	4
        EOR
        DONE
        
Code5D: # EOR Abs,X
        A_ABSX	4
        EOR
        DONE
        
Code5E: # LSR Abs,X
        A_ABSX	7
        LSR
        DONE

Code60: # RTS
        POPW    t0
        addiu   t0, 1
        REALPC  t0
        CLK     6
        DONE
        
Code61: # ADC (Zpg,X)
        A_IX	6
        ADC
        DONE
        
Code65: # ADC Zpg
        A_ZP	v0, 3
        ADC
        DONE
        
Code66: # ROR Zpg
        A_ZP	v0, 5
        ROR
        DONE
        
Code68: # PLA
        POP     s3
        TEST    s3
        CLK     4
        DONE
        
Code69: # ADC #Oper
        A_IMM	v0, 2
        ADC
        DONE
        
Code6A: # ROR A
        RORA
        CLK     2
        DONE
        
Code6C: # JMP (Abs)
        AA_ABS
        READW	5
        JMP     v0
        DONE
        
Code6D: # ADC Abs
        A_ABS	4
        ADC
        DONE
        
Code6E: # ROR Abs
        A_ABS	6
        ROR
        DONE

Code70: # BVS
        BRA     FLAG_V, 1
        
Code71: # ADC (Zpg),Y
        A_IY	5
        ADC
        DONE
        
Code75: # ADC Zpg,X
        A_ZPX	v0, 4
        ADC
        DONE
        
Code76: # ROR Zpg,X
        A_ZPX	v0, 6
        ROR
        DONE
        
Code78: # SEI
        SETF    FLAG_I
        CLK     2
        DONE
        
Code79: # ADC Abs,Y
        A_ABSY	4
        ADC
        DONE
        
Code7D: # ADC Abs,X
        A_ABSX	4
        ADC
        DONE
        
Code7E: # ROR Abs,X
        A_ABSX	7
        ROR
        DONE

Code81: # STA (Zpg,X)
        AA_IX
        STORE   s3, 6
        DONE
        
Code84: # STY Zpg
        AA_ZP
        STORE   s5, 3
        DONE
        
Code85: # STA Zpg
        AA_ZP
        STORE   s3, 3
        DONE
        
Code86: # STX Zpg
        AA_ZP
        STORE   s4, 3
        DONE
        
Code88: # DEY
        subu    s5, s5, 1
        andi    s5, $ff
        TEST    s5
        CLK     2
        DONE
        
Code8A: # TXA
        move    s3, s4
        TEST    s3
        CLK     2
        DONE
        
Code8C: # STY Abs
        AA_ABS
        STORE   s5, 4
        DONE
        
Code8D: # STA Abs
        AA_ABS
        STORE   s3, 4
        DONE
        
Code8E: # STX Abs
        AA_ABS
        STORE   s4, 4
        DONE

Code90: # BCC
        BRA     FLAG_C, 0
        
Code91: # STA (Zpg),Y
        AA_IY
        STORE   s3, 6
        DONE
        
Code94: # STY Zpg,X
        AA_ZPX
        STORE   s5, 4
        DONE
        
Code95: # STA Zpg,X
        AA_ZPX
        STORE   s3, 4
        DONE
        
Code96: # STX Zpg,Y
        AA_ZPY
        STORE   s4, 4
        DONE
        
Code98: # TYA
        move    s3, s5
        TEST    s3
        CLK     2
        DONE
        
Code99: # STA Abs,Y
        AA_ABSY
        STORE   s3, 5
        DONE
        
Code9A: # TXS
        move    s1, s4
        CLK     2
        DONE
        
Code9D: # STA Abs,X
        AA_ABSX
        STORE   s3, 5
        DONE

CodeA0: # LDY #Oper
        A_IMM	s5, 2
        TEST    s5
        DONE
        
CodeA1: # LDA (Zpg,X)
        A_IX	6
        LOAD    s3
        DONE
        
CodeA2: # LDX #Oper
        A_IMM	s4, 2
        TEST    s4
        DONE
        
CodeA4: # LDY Zpg
        A_ZP	s5, 3
        TEST    s5
        DONE
        
CodeA5: # LDA Zpg
        A_ZP	s3, 3
        TEST    s3
        DONE
        
CodeA6: # LDX Zpg
        A_ZP	s4, 3
        TEST    s4
        DONE
        
CodeA8: # TAY
        move    s5, s3
        TEST    s3
        CLK     2
        DONE
        
CodeA9: # LDA #Oper
        A_IMM	s3, 2
        TEST    s3
        DONE
        
CodeAA: # TAX
        move    s4, s3
        TEST    s3
        CLK     2
        DONE
        
CodeAC: # LDY Abs
        A_ABS	4
        LOAD    s5
        DONE
        
CodeAD: # LDA Abs
        A_ABS	4
        LOAD    s3
        DONE
        
CodeAE: # LDX Abs
        A_ABS	4
        LOAD    s4
        DONE

CodeB0: # BCS
        BRA     FLAG_C, 1
        
CodeB1: # LDA (Zpg),Y
        A_IY	5
        LOAD    s3
        DONE
        
CodeB4: # LDY Zpg,X
        A_ZPX	s5, 4
        TEST    s5
        DONE
        
CodeB5: # LDA Zpg,X
        A_ZPX	s3, 4
        TEST    s3
        DONE
        
CodeB6: # LDX Zpg,Y
        A_ZPY	s4, 4
        TEST    s4
        DONE
        
CodeB8: # CLV
        RSTF    FLAG_V
        CLK     2
        DONE
        
CodeB9: # LDA Abs,Y
        A_ABSY	4
        LOAD    s3
        DONE
        
CodeBA: # TSX
        move    s4, s1
        TEST    s4
        CLK     2
        DONE
        
CodeBC: # LDY Abs,X
        A_ABSX	4
        LOAD    s5
        DONE
        
CodeBD: # LDA Abs,X
        A_ABSX	4
        LOAD    s3
        DONE
        
CodeBE: # LDX Abs,Y
        A_ABSY	4
        LOAD    s4
        DONE

CodeC0: # CPY #Oper
        A_IMM	v0, 2
        CMP     s5
        DONE
        
CodeC1: # CMP (Zpg,X)
        A_IX	6
        CMP     s3
        DONE
        
CodeC4: # CPY Zpg
        A_ZP	v0, 3
        CMP     s5
        DONE
        
CodeC5: # CMP Zpg
        A_ZP	v0, 3
        CMP     s3
        DONE
        
CodeC6: # DEC Zpg
        A_ZP	v0, 5
        DEC
        DONE
        
CodeC8: # INY
        addiu   s5, 1
        andi    s5, $ff
        TEST    s5
        CLK     2
        DONE
        
CodeC9: # CMP #Oper
        A_IMM	v0, 2
        CMP     s3
        DONE
        
CodeCA: # DEX
        subu    s4, s4, 1
        andi    s4, $ff
        TEST    s4
        CLK     2
        DONE
        
CodeCC: # CPY Abs
        A_ABS	4
        CMP     s5
        DONE
        
CodeCD: # CMP Abs
        A_ABS	4
        CMP     s3
        DONE
        
CodeCE: # DEC Abs
        A_ABS	6
        DEC
        DONE
        
CodeD0: # BNE
        BRA     FLAG_Z, 0
        
CodeD1: # CMP (Zpg),Y
        A_IY	5
        CMP     s3
        DONE
        
CodeD5: # CMP Zpg,X
        A_ZPX	v0, 4
        CMP     s3
        DONE
        
CodeD6: # DEC Zpg,X
        A_ZPX	v0, 6
        DEC
        DONE
        
CodeD8: # CLD
        RSTF    FLAG_D
        CLK     2
        DONE
        
CodeD9: # CMP Abs,Y
        A_ABSY	4
        CMP     s3
        DONE
        
CodeDD: # CMP Abs,X
        A_ABSX	4
        CMP     s3
        DONE
        
CodeDE: # DEC Abs,X
        A_ABSX	7
        DEC
        DONE

CodeE0: # CPX #Oper
        A_IMM	v0, 2
        CMP     s4
        DONE
        
CodeE1: # SBC (Zpg,X)
        A_IX	6
        SBC
        DONE
        
CodeE4: # CPX Zpg
        A_ZP	v0, 3
        CMP     s4
        DONE
        
CodeE5: # SBC Zpg
        A_ZP	v0, 3
        SBC
        DONE
        
CodeE6: # INC Zpg
        A_ZP	v0, 5
        INC
        DONE
        
CodeE8: # INX
        addiu   s4, 1
        andi    s4, $ff
        TEST    s4
        CLK     2
        DONE
        
CodeE9: # SBC #Oper
        A_IMM	v0, 2
        SBC
        DONE
        
CodeEA: # NOP
        CLK     2
        DONE
        
CodeEC: # CPX Abs
        A_ABS	4
        CMP     s4
        DONE
        
CodeED: # SBC Abs
        A_ABS	4
        SBC
        DONE
        
CodeEE: # INC Abs
        A_ABS	6
        INC
        DONE

CodeF0: # BEQ
        BRA     FLAG_Z, 1
        
CodeF1: # SBC (Zpg),Y
        A_IY	5
        SBC
        DONE
        
CodeF5: # SBC Zpg,X
        A_ZPX	v0, 4
        SBC
        DONE
        
CodeF6: # INC Zpg,X
        A_ZPX	v0, 6
        INC
        DONE
        
CodeF8: # SED
        SETF    FLAG_D
        CLK     2
        DONE
        
CodeF9: # SBC Abs,Y
        A_ABSY	4
        SBC
        DONE
        
CodeFD: # SBC Abs,X
        A_ABSX	4
        SBC
        DONE
        
CodeFE: # INC Abs,X
        A_ABSX	7
        INC
        DONE

CodeXX: # Unknown Instruction
        CLK     2
        DONE

#------------------------------------------------------

LineSync:
        lbu     t0, SPRRAM      	# sprite 0 SPR_Y
        lhu     t1, PPU_Scanline
        addi    t0, 8
        bne     t0, t1, 801f
        nop
        
        sltiu	t0, t1, 8		# SCAN_ON_SCREEN_START
        bne	t0, zero, 801f
        nop
        
        sltiu	t0, t1, 232		# SCAN_BOTTOM_OFF_SCREEN_START
        beq	t0, zero, 801f
        nop
        
        # Set a sprite hit flag
        lbu     t1, PPU_R2
        nop
        ori     t1, $40         	# R2_HIT_SP
        sb      t1, PPU_R2

        # NMI is required if there is necessity
        lbu     t0, PPU_R0
        lbu     t1, PPU_R1
        andi    t0, $40         	# R0_NMI_SP
        beq     t0, zero, 801f
        nop
        andi    t1, $10         	# R1_SHOW_SP
        beq     t0, zero, 801f
        nop

        sb      zero, NMI_STATE 	# NMI_REQ
801:
        #lw     t0, MapperHSync
        #nop
        #jal    t0
        #nop

        lhu     t0, PPU_Scanline
        li      t1, 262         	# SCAN_VBLANK_END
        bne     t0, t1, 802f
        nop
        li      t0, -1
802:
        addi    t0, 1
        sh      t0, PPU_Scanline
        nop
        
        li      t1, 8           	# SCAN_ON_SCREEN_START
        bne     t0, t1, 803f
        nop

	#------------------------------------------------------
	#	Sound effect
	#------------------------------------------------------
	
	li	a0, 4
chloop:
	beq	a0, zero, chloopend
	nop
	sub	a0, 1
	
	lbu	t0, APU_Len(a0)
	nop
	beq	t0, zero, chloop
	nop
	
	sw	a0, 12(sp)

	subu	t0, 1
	sb	t0, APU_Len(a0)
	nop
	beq	t0, zero, soundoff
	nop

	sll	t1, a0, 2
	lbu	t0, APU_Reg + 1(t1)
	nop
	andi	t3, t0, 8
	andi	t1, t0, $87
	slti	t1, t1, $81
	bne	t1, zero, envfx
	nop
	
freqfx:
	# freq. effect
	andi	t1, t0, $7
	sll	t1, 3
	andi	t2, t0, $70
	srl	t2, 4
	or	t1, t2
	li	t2, 64
	sub	t0, t2, t1
	
	sll	t4, a0, 1
	lhu	a1, APU_Freq(t4)
	
	bne	t3, zero, 111f
	nop
	
	sub	a1, t0
	bgez	a1, 222f
	nop

	sb	zero, APU_Len(a0)
	nop
	j	soundoff
	nop
111:
	addu	a1, t0
	slti	t2, a1, 16384
	bne	t2, zero, 222f
	nop
	sb	zero, APU_Len(a0)
	nop
	j	soundoff
	nop
222:
	sh	a1, APU_Freq(t4)

	jal	pNesX_SetFreq
	nop

	lw	a0, 12(sp)
	nop
	
envfx:
	# env. fx
	
	
	
	
	j	chloop
	nop
	
soundoff:
	li	a1, 0
	jal	pNesX_SetVolume
	nop

	lw	a0, 12(sp)
	
	lbu	t0, APU_Reg + $15
	li	t1, 1
	sll	t1, a0
	xor	t1, $ff
	and	t0, t1
	sb	t0, APU_Reg + $15
	nop
	
	j	chloop
	nop
	
chloopend:
	#------------------------------------------------------

        # Reset a PPU status
        sb      zero, PPU_R2
        
        lbu     t0, NesHeader + 5       # NesHeader.byVRomSize
        lhu     t1, FrameCnt
        nop
        add     t0, t1
        bne     t0, zero, 805f
        nop
        jal     pNesX_SetupChr
        nop
        j       805f
        nop
803:
        li      t1, 243         	# SCAN_VBLANK_START
        bne     t0, t1, 805f
        nop

	# Frame IRQ
	lbu	t1, chFrameIRQ
	nop
	xori	t1, 1
	sb	t1, IRQ_STATE		# Set frame IRQ mode

        lhu     t0, FrameCnt
        nop
        bne     t0, zero, 813f
        nop
        jal     pNesX_LoadFrame
        nop
813:
        # FrameCnt
        lhu     t1, FrameCnt
        nop
        xori    t1, 1
        sh      t1, FrameCnt
        
        li      t0, $80         	# R2_IN_VBLANK
        sb      t0, PPU_R2
        sb      zero, PPU_Latch_Flag
        
        lw      t0, MapperVSync
        nop
        jal     t0
        nop
        la      a0, PAD1_Latch
        la      a1, PAD2_Latch
        la      a2, PAD_System
        jal     pNesX_PadState
        nop
        lbu     t0, PPU_R0
        nop
        andi    t0, $80         	# R0_NMI_VB
        beq     t0, zero, 804f
        nop
        sb      zero, NMI_STATE 	# NMI_REQ
804:
        lw      t0, PAD_System
        nop
        andi    t0, 1           	# PAD_SYS_QUIT
        beq     t0, zero, 805f
        nop
        j       EmuQuit
        nop
805:
        lbu     t0, NMI_STATE
        nop
        bne     t0, zero, 806f
        nop
        
        CLK     7
        VIRPC   t0
        PUSHW   t0
        andi    t1, s2, FLAG_B ^ $ff
        PUSH    t1
        RSTF    FLAG_D
        li      a0, $fffa       	# VECTOR_NMI
        jal     K6502_ReadW
        nop
        REALPC  v0

	li	t0, 1
        sb      t0, NMI_STATE
        
        j       807f
        nop
806:
        lbu     t0, IRQ_STATE
        nop
        bne     t0, zero, 807f
        nop
        andi    t0, s2, FLAG_I
        bne     t0, zero, 807f
        nop
        
        CLK     7
        VIRPC   t0
        PUSHW   t0
        andi    t1, s2, FLAG_B ^ $ff
        PUSH    t1
        RSTF    FLAG_D
        SETF    FLAG_I
        li      a0, $fffe       	# VECTOR_IRQ
        jal     K6502_ReadW
        nop
        REALPC  v0

	li	t0, 1
        sb      t0, IRQ_STATE
        
807:
        
        CLK     -LINE_CLK
        
        j       Fetch2
        nop

EmuQuit:
        sh      s0, SP_CLOCK
        sb      s1, SP_SP
        sb      s2, SP_F
        sb      s3, SP_A
        sb      s4, SP_X
        sb      s5, SP_Y
        sw      s6, SP_PPC
        sw      s7, SP_PPC_OFF

        lw      ra, 16(sp)
        lw      s0, 20(sp)
        lw      s1, 24(sp)
        lw      s2, 28(sp)
        lw      s3, 32(sp)
        lw      s4, 36(sp)
        lw      s5, 40(sp)
        lw      s6, 44(sp)
        lw      s7, 48(sp)
        addi    sp, sp, 9 * 4 + 16

        jr      ra
        nop
        .end    K6502_Run


